---
title: "Create SOW for a project"
description: "Creates a Statement of Work belonging to the given project"
---

> Documentation Index
> Fetch the complete documentation index at: https://docs.testandaccept.com/llms.txt
> Use this file to discover all available pages before exploring further.

Path: Test And Accept API › Projects

`POST /projects/{id}/sows`

Creates a Statement of Work belonging to the given project

## Authentication

- `bearerAuth`, http, header `Authorization`, format `tnda_ token`

## Path parameters

- `id` (`projects-createSow.path.id`; string, required)
  - format `uuid`; pattern `^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000)$`

## Request body

_Required._

- `title` (`projects-createSow.title`; string, required)
  - minLength 1; maxLength 255
- `description` (`projects-createSow.description`; string, optional)
- `status` (`projects-createSow.status`; string, optional)
  - default `"draft"`
- `dueDate` (`projects-createSow.dueDate`; string, optional)
  - format `date-time`; pattern `^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$`

## Example request

```json
{
  "title": "string",
  "description": "string",
  "status": "draft",
  "dueDate": "2019-08-24T14:15:22Z"
}
```

## Code samples

### cURL

```bash
curl --request POST \
  --url 'https://api.testandaccept.com/api/rest/projects/<id>/sows' \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --data '
{
  "title": "string",
  "description": "string",
  "status": "draft",
  "dueDate": "2019-08-24T14:15:22Z"
}
'
```

### TypeScript

```typescript
const url = 'https://api.testandaccept.com/api/rest/projects/<id>/sows';
const options = {
  method: 'POST',
  headers: {'Content-Type': 'application/json', Authorization: 'Bearer <token>'},
  body: JSON.stringify({
    title: 'string',
    description: 'string',
    status: 'draft',
    dueDate: '2019-08-24T14:15:22Z'
  })
};

fetch(url, options)
  .then(res => res.json())
  .then(json => console.log(json))
  .catch(err => console.error(err));
```

### Python

```python
import requests

url = "https://api.testandaccept.com/api/rest/projects/<id>/sows"

payload = {
    "title": "string",
    "description": "string",
    "status": "draft",
    "dueDate": "2019-08-24T14:15:22Z"
}
headers = {
    "Content-Type": "application/json",
    "Authorization": "Bearer <token>"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)
```

## Responses

### 200

Successful response

#### Example

```json
{
  "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
  "title": "string",
  "description": "string",
  "projectId": "5a8591dd-4039-49df-9202-96385ba3eff8",
  "ownerUserId": "string",
  "organizationId": "string",
  "status": "string",
  "currentVersion": 0,
  "orderIndex": 0,
  "isArchived": true,
  "isPinned": true,
  "dueDate": "2019-08-24T14:15:22Z",
  "archivedAt": "2019-08-24T14:15:22Z",
  "pinnedAt": "2019-08-24T14:15:22Z",
  "primaryContactId": "6995e343-1ae2-4fcb-a7c9-3e426dba8dc0",
  "createdAt": "2019-08-24T14:15:22Z",
  "updatedAt": "2019-08-24T14:15:22Z"
}
```

- `id` (`projects-createSow.response.200.id`; string, required)
  - format `uuid`; pattern `^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000)$`
- `title` (`projects-createSow.response.200.title`; string, required)
- `description` (`projects-createSow.response.200.description`; any of, required)
  - any of: `string`, `null`
- `projectId` (`projects-createSow.response.200.projectId`; any of, required)
  - any of: `string`, `null`
- `ownerUserId` (`projects-createSow.response.200.ownerUserId`; string, required)
- `organizationId` (`projects-createSow.response.200.organizationId`; any of, required)
  - any of: `string`, `null`
- `status` (`projects-createSow.response.200.status`; string, required)
- `currentVersion` (`projects-createSow.response.200.currentVersion`; number, required)
- `orderIndex` (`projects-createSow.response.200.orderIndex`; number, required)
- `isArchived` (`projects-createSow.response.200.isArchived`; boolean, required)
- `isPinned` (`projects-createSow.response.200.isPinned`; boolean, required)
- `dueDate` (`projects-createSow.response.200.dueDate`; any of, required)
  - any of: `string`, `null`
- `archivedAt` (`projects-createSow.response.200.archivedAt`; any of, required)
  - any of: `string`, `null`
- `pinnedAt` (`projects-createSow.response.200.pinnedAt`; any of, required)
  - any of: `string`, `null`
- `primaryContactId` (`projects-createSow.response.200.primaryContactId`; any of, required)
  - any of: `string`, `null`
- `createdAt` (`projects-createSow.response.200.createdAt`; string, required)
  - format `date-time`; pattern `^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$`
- `updatedAt` (`projects-createSow.response.200.updatedAt`; string, required)
  - format `date-time`; pattern `^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$`

### 400

Invalid input data

#### Example

```json
{
  "code": "BAD_REQUEST",
  "message": "Invalid input data",
  "issues": []
}
```

- `message` (`projects-createSow.response.400.message`; string, required) — The error message
  - example `"Invalid input data"`
- `code` (`projects-createSow.response.400.code`; string, required) — The error code
  - example `"BAD_REQUEST"`
- `issues` (`projects-createSow.response.400.issues`; array<object>, optional) — An array of issues that were responsible for the error
  - example `[]`
  - `message` (`projects-createSow.response.400.issues.message`; string, required)

### 401

Authorization not provided

#### Example

```json
{
  "code": "UNAUTHORIZED",
  "message": "Authorization not provided",
  "issues": []
}
```

- `message` (`projects-createSow.response.401.message`; string, required) — The error message
  - example `"Authorization not provided"`
- `code` (`projects-createSow.response.401.code`; string, required) — The error code
  - example `"UNAUTHORIZED"`
- `issues` (`projects-createSow.response.401.issues`; array<object>, optional) — An array of issues that were responsible for the error
  - example `[]`
  - `message` (`projects-createSow.response.401.issues.message`; string, required)

### 403

Insufficient access

#### Example

```json
{
  "code": "FORBIDDEN",
  "message": "Insufficient access",
  "issues": []
}
```

- `message` (`projects-createSow.response.403.message`; string, required) — The error message
  - example `"Insufficient access"`
- `code` (`projects-createSow.response.403.code`; string, required) — The error code
  - example `"FORBIDDEN"`
- `issues` (`projects-createSow.response.403.issues`; array<object>, optional) — An array of issues that were responsible for the error
  - example `[]`
  - `message` (`projects-createSow.response.403.issues.message`; string, required)

### 500

Internal server error

#### Example

```json
{
  "code": "INTERNAL_SERVER_ERROR",
  "message": "Internal server error",
  "issues": []
}
```

- `message` (`projects-createSow.response.500.message`; string, required) — The error message
  - example `"Internal server error"`
- `code` (`projects-createSow.response.500.code`; string, required) — The error code
  - example `"INTERNAL_SERVER_ERROR"`
- `issues` (`projects-createSow.response.500.issues`; array<object>, optional) — An array of issues that were responsible for the error
  - example `[]`
  - `message` (`projects-createSow.response.500.issues.message`; string, required)


Source: https://docs.testandaccept.com/reference/projects/create-sow/index.md
